program rc;

{$R *.res}

uses
  Windows, Messages;

  type
  TParMsg = record
    Par1: String;
    Par2: String;
    Msg:  Cardinal;
    end;

  var
  WinClass: TWndClassA;
  Inst, Handle, RHandle, Button_OK, CommandListEdit, hFont: Integer;
  Msg: TMsg;
  I, TempNo: Integer;
  TempString: String;
  MsgNo: Cardinal;

  const
  WINDOW_WIDTH=600;
  WINDOW_HEIGHT=350;
  BUTTON_WIDTH=120;
  BUTTON_HEIGHT=35;
  RADIATOR_CLASS_NAME='TMainRadioForm';

  //messages
  WM_MyVolUp=WM_USER + 1001;
  WM_MyVolDown=WM_USER + 1002;
  WM_MyMute=WM_USER + 1003;
  WM_MyUnmute=WM_USER + 1004;
  WM_MyStatUp=WM_USER + 1005;
  WM_MyStatDown=WM_USER + 1006;
  WM_MyLastStat=WM_USER + 1007;
  WM_MySurf=WM_USER + 1008;
  WM_MyTuneStatNo=WM_USER + 1009;
  WM_MyTuneFr=WM_USER + 1010;
  WM_MyMin=WM_USER + 1011;
  WM_MyMax=WM_USER + 1012;
  WM_MyThin=WM_USER + 1013;
  WM_MyRecord=WM_USER + 1014;
  WM_MyRadClose=WM_USER + 1015;
  WM_MyRestore=WM_USER + 1016;
  WM_MyMonoStereo=WM_USER + 1017;
  WM_MyStereo=WM_USER + 1018;
  WM_MyMono=WM_USER + 1019;
  WM_MyMuteUnmute=WM_USER + 1020;
  WM_MyToggleThin=WM_USER + 1021;
  WM_MyToggleTray=WM_USER + 1022;
  WM_MyFineTuneUp=WM_USER + 1023;
  WM_MyFineTuneDown=WM_USER + 1024;
  WM_MyCoarseTuneUp=WM_USER + 1025;
  WM_MyCoarseTuneDown=WM_USER + 1026;
  WM_MyScanUp=WM_USER + 1027;
  WM_MyScanDown=WM_USER + 1028;
  WM_MyToggleOnTop=WM_USER + 1029;
  WM_MyLCD=WM_USER + 1030;
  WM_MyRecordName=WM_USER + 1031;
  WM_MyLockLCD=WM_USER + 1032;
  WM_MyReleaseLCD=WM_USER + 1033;
  WM_MyRefreshLCD=WM_USER + 1034;
  WM_MyLoopOn=WM_USER + 1035;
  WM_MyLoopOff=WM_USER + 1036;
  WM_MyToggleLoop=WM_USER + 1037;


  ArrayParMsg: array[1..34] of TParMsg =
     (
     (Par1: 'voldown';      Par2: 'vd';  Msg: WM_MyVolDown),
     (Par1: 'volup';        Par2: 'vu';  Msg: WM_MyVolUp),
     (Par1: 'mute';         Par2: 'm';   Msg: WM_MyMute),
     (Par1: 'unmute';       Par2: 'u';   Msg: WM_MyUnMute),
     (Par1: 'statup';       Par2: 'su';  Msg: WM_MyStatUp),
     (Par1: 'statdown';     Par2: 'sd';  Msg: WM_MyStatDown),
     (Par1: 'last';         Par2: 'l';   Msg: WM_MyLastStat),
     (Par1: 'surf';         Par2: 'f';   Msg: WM_MySurf),
     (Par1: 'min';          Par2: 'n';   Msg: WM_MyMin),
     (Par1: 'max';          Par2: 'x';   Msg: WM_MyMax),
     (Par1: 'thin';         Par2: 't';   Msg: WM_MyThin),
     (Par1: 'record';       Par2: 'r';   Msg: WM_MyRecord),
     (Par1: 'close';        Par2: 'c';   Msg: WM_MyRadClose),
     (Par1: 'restore';      Par2: 'e';   Msg: WM_MyRestore),
     (Par1: 'monostereo';   Par2: 'ms';  Msg: WM_MyMonoStereo),
     (Par1: 'stereo';       Par2: 'st';  Msg: WM_MyStereo),
     (Par1: 'mono';         Par2: 'mo';  Msg: WM_MyMono),
     (Par1: 'muteunmute';   Par2: 'mu';  Msg: WM_MyMuteUnmute),
     (Par1: 'togglethin';   Par2: 'tt';  Msg: WM_MyToggleThin),
     (Par1: 'toggletray';   Par2: 'ttr'; Msg: WM_MyToggleTray),
     (Par1: 'finetuneup';   Par2: 'fu';  Msg: WM_MyFineTuneUp),
     (Par1: 'finetunedown'; Par2: 'fd';  Msg: WM_MyFineTuneDown),
     (Par1: 'tuneup';       Par2: 'tu';  Msg: WM_MyCoarseTuneUp),
     (Par1: 'tunedown';     Par2: 'td';  Msg: WM_MyCoarseTuneDown),
     (Par1: 'scanup';       Par2: 'scu'; Msg: WM_MyScanUp),
     (Par1: 'scandown';     Par2: 'scd'; Msg: WM_MyScanDown),
     (Par1: 'ontop';        Par2: 'ot';  Msg: WM_MyToggleOnTop),
     (Par1: 'terminate';    Par2: 'ter'; Msg: WM_Close),
     (Par1: 'locklcd';      Par2: 'll';  Msg: WM_MyLockLCD),
     (Par1: 'releaselcd';   Par2: 'lr';  Msg: WM_MyReleaseLCD),
     (Par1: 'refreshlcd';   Par2: 'lf';  Msg: WM_MyRefreshLCD),
     (Par1: 'loopon';       Par2: 'lo';  Msg: WM_MyLoopOn),
     (Par1: 'loopoff';      Par2: 'loff';  Msg: WM_MyLoopOff),
     (Par1: 'toggleloop';   Par2: 'tl';  Msg: WM_MyToggleLoop)
      );

function StrToInt(const S: string): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
end;

function LowerCase(const S: string): string;
var
  Ch: Char;
  L: Integer;
  Source, Dest: PChar;
begin
  L := Length(S);
  SetLength(Result, L);
  Source := Pointer(S);
  Dest := Pointer(Result);
  while L <> 0 do
  begin
    Ch := Source^;
    if (Ch >= 'A') and (Ch <= 'Z') then Inc(Ch, 32);
    Dest^ := Ch;
    Inc(Source);
    Inc(Dest);
    Dec(L);
  end;
end;

procedure SendWM_CopyData(Handle, WM_MessageNumber: Integer; Text: string);
var
  CopyData: TCopyDataStruct;
begin
    with CopyData do begin
      dwData := WM_MessageNumber;
      cbData := Length(Text)+1;
      lpData := @Text[1];
    end;
    SendMessage(Handle, WM_COPYDATA, 0, LPARAM( @CopyData ));
end;

function WindowProc(hWnd, uMsg, wParam, lParam: Integer): Integer; stdcall;
begin
  Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  if (lParam = Button_OK) and (uMsg = WM_COMMAND) then Halt;
  if uMsg = WM_DESTROY then Halt;
end;

begin
  Inst := hInstance;
  with WinClass do
    begin
    style              := CS_CLASSDC + CS_PARENTDC;
    lpfnWndProc        := @WindowProc;
    hInstance          := Inst;
    hbrBackground      := Color_BtnFace + 1;
    lpszClassname      := 'RADIATOR_REMOTE';
    hIcon              := LoadIcon(hInstance,'MAINICON');
    hCursor            := LoadCursor(0, IDC_ARROW);
  end;
  RegisterClass(WinClass);

  if ParamCount=0 then begin

  Handle:= CreateWindowEx(WS_EX_WINDOWEDGE, 'RADIATOR_REMOTE', 'Radiator remote control',
            WS_EX_TOPMOST + WS_VISIBLE + WS_SIZEBOX + WS_CAPTION + WS_SYSMENU,
            GetSystemMetrics(SM_CXSCREEN) div 2 -   WINDOW_WIDTH div 2,
            GetSystemMetrics(SM_CYSCREEN) div 2 -   WINDOW_HEIGHT div 2,
            WINDOW_WIDTH, WINDOW_HEIGHT, 0, 0, Inst, nil);

  Button_OK := CreateWindow('Button', 'OK', WS_VISIBLE + WS_CHILD + BS_PUSHLIKE + BS_TEXT + BS_DEFPUSHBUTTON,
                             WINDOW_WIDTH div 2 - BUTTON_WIDTH div 2,
                             WINDOW_HEIGHT - (BUTTON_HEIGHT + 40),
                             BUTTON_WIDTH, BUTTON_HEIGHT, Handle, 0, Inst, nil);

  CommandListEdit := CreateWindowEx(WS_EX_CLIENTEDGE, 'Edit', '',
                     WS_CHILD + WS_VISIBLE + WS_BORDER + WS_VSCROLL +
                     ES_MULTILINE + ES_READONLY +  ES_AUTOVSCROLL,
                     10,10, WINDOW_WIDTH -30, WINDOW_HEIGHT -100, Handle, 0, Inst, nil);

  hFont := CreateFont(-11, 0, 0, 0, 400, 0, 0, 0, DEFAULT_CHARSET,
                      OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
                      DEFAULT_PITCH + FF_DONTCARE, 'MS Sans Serif');

 if hFont <> 0 then
  begin
    SendMessage(Button_OK, WM_SETFONT, hFont, 0);
    SendMessage(CommandListEdit, WM_SETFONT, hFont, 0);
  end;

  TempString:=
   'This is a command-line utility which can control Radiator. '
  +'For newest version please check http://flesko.cz.' + #13 + #10+#13 + #10

  +'LIST OF POSSIBLE PARAMETERS AND THEIR MEANINGS:' + #13 + #10
  +'Parameters are separated by spaces: rc command1 command 2' + #13 + #10
  +'Example: rc fr8970 x vu (tune frequency 89.70 MHz, maximize Radiator and set volume up).' + #13 + #10+#13 + #10

  +'TUNING:' + #13 + #10
  +'fr: tune frequency (fr10685 for 106.85 MHz)' + #13 + #10
  +'finetuneup, fu: fine tune up' + #13 + #10
  +'finetunedown, fd: fine tune down' + #13 + #10
  +'tuneup, tu: coarse tune up' + #13 + #10
  +'tunedown, td: coarse tune down' + #13 + #10
  +'scanup, scu: scan up' + #13 + #10
  +'scanup, scd: scan down' + #13 + #10+#13 + #10

  +'STATIONS:' + #13 + #10
  +'no: station number (no11 for switching to station No. 11)' + #13 + #10
  +'statup, su: station up' + #13 + #10
  +'statdown, sd: station down' + #13 + #10
  +'last, l: last station' + #13 + #10
  +'surf, f: station surfing' + #13 + #10+#13 + #10

  +'SOUND:' + #13 + #10
  +'muteunmute, mu: toggle mute/unmute' + #13 + #10
  +'mute, m: mute sound' + #13 + #10
  +'unmute, u: unmute sound' + #13 + #10
  +'volup, vu: volume up' + #13 + #10
  +'voldown, vd: volume down' + #13 + #10
  +'monostereo, ms: toggle mono/stereo' + #13 + #10
  +'stereo, st: stereo' + #13 + #10
  +'mono, mo: mono' + #13 + #10+#13 + #10

  +'RECORDING:' + #13 + #10
  +'loopon, lo: set loop recording on' +#13 + #10
  +'loopoff, loff: set loop recording off' +#13 + #10
  +'toggleloop, tl: toggle loop recording on/off' +#13 + #10
  +'record, r: begin/stop recording' +#13 + #10
  +'(when stopping recording it will ask for name of the recorded file)' + #13 + #10+#13 + #10
  +'sr: stop recording and save it with given name' + #13 + #10
  +'(Example: sr"C:\Music\My Name Of The File.wav"' + #13 + #10
  +'or' + #13 + #10
  +'srMyFile.wav' + #13 + #10
  +'or' + #13 + #10
  +'sr without parameter for automatical naming' + #13 + #10 + #13 + #10
  +'Use quotation marks " " when filename contains one or more spaces).' + #13 + #10+ #13 + #10
  +'You can use variables in filename: %y (Year), %m (Month), %d (Day), '
  +'%h (Hour), %n (miNutes), %s (Seconds), %f (Frequency in MHz - e.g. 89_70), '
  +'%b (station numBer),  %a (station nAme), %l (Login name in Windows), %c (Codec name).' + #13 + #10 + #13 + #10
  +'(Example: sr"C:\Music\Show from %a on %d-%m (%y) at %h-%n by %l.wav" could result in:' + #13 + #10
  +'C:\Music\Show from Radio Life on 25-10 (2001) at 15-03 by Mirek.wav)' + #13 + #10 + #13 + #10
  +'Make sure that length of the filename (including path) will not exceed file name length'
  +' limitation of OS (for example: file names are limited to 255 characters in Windows 95).'+ #13 + #10 +#13 + #10

  +'OTHER:' + #13 + #10
  +'lcd: set LCD text (lcd"Give me a break ...")' + #13 + #10
  +'locklcd, ll: prevent LCD from being updating by any other way than by WM_MyLCD message'+ #13 + #10
  +'releaselcd, lr: unlock LCD previously locked by  WM_MyLockLCD'+ #13 + #10
  +'refreshlcd, lf: force Radiator to refresh LCD'+ #13 + #10
  +'min, n: minimize' + #13 + #10
  +'max, x: maximize' + #13 + #10
  +'thin, t: thin window' + #13 + #10
  +'togglethin, tt: toggle thin/full size window' + #13 + #10
  +'toggletray, ttr: toggle minimized (tray)/window modes' + #13 + #10
  +'restore, e: restore from tray icon' + #13 + #10
  +'ontop, ot: toggle on/off always on top' + #13 + #10
  +'close, c: close Radiator' + #13 + #10
  +'terminate, ter: shutdown' + #13 + #10 + #13 + #10

  +'Copyright 2001 Miroslav Flesko. Made in Czech Republic.';

  SetWindowText(CommandListEdit,PChar(TempString));
  SetFocus(Button_OK);
  UpdateWindow(Handle);

  while(GetMessage(Msg, Handle, 0, 0)) do
  begin
    TranslateMessage(msg);
    DispatchMessage(msg);
  end; // with

  end else begin
  RHandle:= FindWindow(RADIATOR_CLASS_NAME, nil);
  for I:= 1 to ParamCount do begin
    TempString:= LowerCase(ParamStr(I));
    MsgNo:= 0;
    // search for command line parameter
    for TempNo:= Low(ArrayParMsg) to High(ArrayParMsg) do
      if (TempString = ArrayParMsg[TempNo].Par1) or
         (TempString = ArrayParMsg[TempNo].Par2) then begin
        MsgNo:= ArrayParMsg[TempNo].Msg;
        break;
      end;

    if MsgNo <> 0 then // found command line parameter
      PostMessage(RHandle, MsgNo, 0, 0) // post appropriate message
    else

    //messages with parameters
    if Copy(TempString, 1, 2) = 'no'
      then begin
      try
      TempNo:=StrToInt(Copy(LowerCase(ParamStr(I)),3,2));
      if (TempNo<>0) and  (TempNo<=24) then PostMessage(RHandle, WM_MyTuneStatNo, TempNo, 0);
      except end
      end else

    if Copy(TempString, 1, 2) = 'fr'
      then begin
      try
      TempNo:=StrToInt(Copy(LowerCase(ParamStr(I)),3,5));
      PostMessage(RHandle, WM_MyTuneFr, TempNo, 0);
      except end
      end else

    if Copy(TempString, 1, 3) = 'lcd'
    then SendWM_CopyData(RHandle, WM_MyLCD, Copy(ParamStr(I),4,Length(ParamStr(I))-3))
    else

    if Copy(TempString,1,2) = 'sr'
    then SendWM_CopyData(RHandle, WM_MyRecordName, Copy(ParamStr(I),3,Length(ParamStr(I))-2));

  end;
  end;

  Halt;

end.
